//======================================
//  HUSB-DIO464 Driver I/F DLL Function
//	    file name:hudio464.h
//	Copyright(C) 2002-2019  Hivertec Inc.  
//  All Rights Reserved.
//======================================

#define NOT_FOUND			0x00000001
#define ALREADY_OPENED		0x00000002
#define NOT_MEMORY			0x00000004
#define INVALID_HANDLE		0x00000008
#define NOT_READY			0x00000010
#define ILLEGAL_DEVICE		0x00000020
#define ILLEGAL_ACCESS		0x00000040
#define USB_TIMEOUT			0x00000080
#define ILLEGAL_PARAM		0x00000100
#define ILLEGAL_COMMAND		0x00000200
#define ILLEGAL_RESPONSE	0x00000400

// -----------------
//		\
// -----------------
// foCX
typedef struct _HUSBDEVINF {		// foCX
	WORD			BrdID;			// {[hID( 0`15 )
	WORD			EPcnt;			// DIO464/v2:߲Đ(>=2)					/DIO464U/T/W:=1
	WORD			EPspc[8];		// DIO464/v2:߲Ďdl(0x81,0x02/0x02,0x86)	/DIO464U/T/W:[0]COM߰ؽĲޯԍ(0`)
	WORD			EPsiz[8];		// DIO464/v2:߲ĥ޲Đ(32,32, 0, 0)		/DIO464U/T/W:[0]COM|[gԍ(1`65535)
	WORD			EPopt[8];		// DIO464/v2:߲ĥ߼( \ )			/DIO464U/T/W:0
	HANDLE			EPhdl[8];		// DIO464/v2:߲ĥ(߲)		/DIO464U/T/W:[0]COM߰
} HUSBDEVINF, *PHUSBDEVINF;

//------------------------------
//	DLL֐vg^Cv
//------------------------------
#ifdef __cplusplus		// for Microsoft C/C++
extern "C"
{
#endif

// 1.foCX̎擾(FfoCX̌)
__declspec(dllimport) DWORD WINAPI dio464_GetDeviceCount(DWORD*);

// 2.foCX̎擾(FfoCX̌AfoCX񃊃Xg̐擪AhX)
__declspec(dllimport) DWORD WINAPI dio464_GetDeviceInfo(DWORD*, HUSBDEVINF*);

// 3.foCXI[v(FfoCXnh̃AhXAfoCX̃AhX)
__declspec(dllimport) DWORD WINAPI dio464_OpenDevice(DWORD*, HUSBDEVINF*);

// 4.foCXN[Y(FfoCXnh)
__declspec(dllimport) DWORD WINAPI dio464_CloseDevice(DWORD);

// 5.̓|[gPoCgǏo(FfoCXnhA|[gԍAf[^i[)
__declspec(dllimport) DWORD WINAPI dio464_rInB(DWORD, WORD, WORD*);

// 6.o̓|[gPoCgǏo(FfoCXnhA|[gԍAf[^i[)
__declspec(dllimport) DWORD WINAPI dio464_rOutB(DWORD, WORD, WORD*);

// 7.o̓|[gPoCg(FfoCXnhA|[gԍAo̓f[^)
__declspec(dllimport) DWORD WINAPI dio464_wOutB(DWORD, WORD, WORD);

// 8.̓|[gQoCgǏo(FfoCXnhA|[gԍAf[^i[)
__declspec(dllimport) DWORD WINAPI dio464_rInW(DWORD, WORD, WORD*);

// 9.o̓|[gQoCgǏo(FfoCXnhA|[gԍAf[^i[)
__declspec(dllimport) DWORD WINAPI dio464_rOutW(DWORD, WORD, WORD*);

// 10.o̓|[gQoCg(FfoCXnhA|[gԍAo̓f[^)
__declspec(dllimport) DWORD WINAPI dio464_wOutW(DWORD, WORD, WORD);

// 11.̓|[gSoCgǏo(FfoCXnhAf[^i[)
__declspec(dllimport) DWORD WINAPI dio464_rInDW(DWORD, DWORD*);

// 12.o̓|[gSoCgǏo(FfoCXnhAf[^i[)
__declspec(dllimport) DWORD WINAPI dio464_rOutDW(DWORD, DWORD*);

// 13.o̓|[gSoCg(FfoCXnhAo̓f[^)
__declspec(dllimport) DWORD WINAPI dio464_wOutDW(DWORD, DWORD);

// 14.̓|[gSoCgǏoo̓|[gSoCg(FfoCXnhA̓f[^i[Ao̓f[^)
__declspec(dllimport) DWORD WINAPI dio464_InOutDW(DWORD, DWORD*, DWORD);

// 15.tB^ݒ(FfoCXnhA|[gwATvO)
//ii(DIO464/464v2)݊j
__declspec(dllimport) DWORD WINAPI dio464_SetFilter(DWORD, WORD, DWORD);

// 16.tB^ݒ(FfoCXnhA|[gwAtB^[ԍ)
//iVi(DIO464U/T/W)̂ݎgp\j
__declspec(dllimport) DWORD WINAPI dio464_SetFilterEx(DWORD, WORD, WORD);

// 17.{[hŗLR[h(HEX4)̎擾(FfoCXnhAR[hi[)
__declspec(dllimport) DWORD WINAPI dio464_GetBoardCode(DWORD, WORD*);

// 18.{[h^Cv̎擾(FfoCXnhA^Cvi[)
__declspec(dllimport) DWORD WINAPI dio464_GetBoardType(DWORD, WORD*);

// 19.o[W擾(FfoCXnhAo[Wi[)
__declspec(dllimport) DWORD WINAPI dio464_rVersion(DWORD, WORD*);

// 20.USBM(FfoCXnhAMf[^AMf[^)
__declspec(dllimport) DWORD WINAPI dio464_UsbSend(DWORD, BYTE*, WORD*);

// 21.USBM(FfoCXnhAf[^i[AMf[^)
__declspec(dllimport) DWORD WINAPI dio464_UsbRecv(DWORD, BYTE*, WORD*);

#ifdef __cplusplus
}
#endif

